package main

import (
	"bufio"
	"errors"
	"fmt"
	"io"
	"os"
	"strconv"
	"strings"
)

func importFile(file string) ([][]int, error) {
	var err error
	var mySlice = make([][]int, 0)

	f, err := os.Open(file)
	if err != nil {
		return nil, err
	}
	defer f.Close()

	r := bufio.NewReader(f)
	for {
		line, err := r.ReadString('\n')
		fields := strings.Fields(line)
		temp := make([]int, 0)
		for _, v := range fields {
			n, err := strconv.Atoi(v)
			if err != nil {
				return nil, err
			}
			temp = append(temp, n)
		}
		if len(temp) != 0 {
			mySlice = append(mySlice, temp)
		}

		if err == io.EOF {
			break
		} else if err != nil {
			return nil, err
		}

		if len(temp) != len(mySlice[0]) {
			return nil, errors.New("Wrong number of elements!")
		}

	}
	return mySlice, nil
}

func main() {
	arguments := os.Args
	if len(arguments) == 1 {
		fmt.Printf("usage: loadFile textFile\n")
		return
	}

	file := arguments[1]
	mySlice, err := importFile(file)
	if err != nil {
		fmt.Println(err)
		return
	}
	for _, v := range mySlice {
		fmt.Println(v)
	}
}
